<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - coverage.info - proyecto/tb_top_estimator.vhd</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">proyecto</a> - tb_top_estimator.vhd<span style="font-size: 80%;"> (source / <a href="tb_top_estimator.vhd.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">coverage.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">84</td>
            <td class="headerCovTableEntry">95</td>
            <td class="headerCovTableEntryMed">88.4 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2023-02-09 17:19:34</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">12</td>
            <td class="headerCovTableEntry">12</td>
            <td class="headerCovTableEntryHi">100.0 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span><span class="lineCov">          6 : library ieee;</span></a>
<a name="2"><span class="lineNum">       2 </span>            : use ieee.std_logic_1164.all;</a>
<a name="3"><span class="lineNum">       3 </span>            : use ieee.numeric_std.all;</a>
<a name="4"><span class="lineNum">       4 </span>            : </a>
<a name="5"><span class="lineNum">       5 </span>            : library src_lib;</a>
<a name="6"><span class="lineNum">       6 </span>            : use src_lib.edc_common.all;</a>
<a name="7"><span class="lineNum">       7 </span>            : use src_lib.transactions_estimator.all;</a>
<a name="8"><span class="lineNum">       8 </span>            : --</a>
<a name="9"><span class="lineNum">       9 </span>            : library vunit_lib;</a>
<a name="10"><span class="lineNum">      10 </span>            : context vunit_lib.vunit_context;</a>
<a name="11"><span class="lineNum">      11 </span><span class="lineCov">          2 : context vunit_lib.com_context;</span></a>
<a name="12"><span class="lineNum">      12 </span><span class="lineCov">          2 : </span></a>
<a name="13"><span class="lineNum">      13 </span><span class="lineCov">         42 : library osvvm;</span></a>
<a name="14"><span class="lineNum">      14 </span><span class="lineCov">          2 : use osvvm.randompkg.all;</span></a>
<a name="15"><span class="lineNum">      15 </span>            : use osvvm.coveragepkg.all;</a>
<a name="16"><span class="lineNum">      16 </span><span class="lineCov">         82 : </span></a>
<a name="17"><span class="lineNum">      17 </span><span class="lineCov">          2 : </span></a>
<a name="18"><span class="lineNum">      18 </span>            : context osvvm.OsvvmContext;</a>
<a name="19"><span class="lineNum">      19 </span>            : </a>
<a name="20"><span class="lineNum">      20 </span>            : </a>
<a name="21"><span class="lineNum">      21 </span>            : </a>
<a name="22"><span class="lineNum">      22 </span><span class="lineCov">         12 : entity top_estimator_tb is</span></a>
<a name="23"><span class="lineNum">      23 </span>            :   generic (runner_cfg : string);</a>
<a name="24"><span class="lineNum">      24 </span>            : end;</a>
<a name="25"><span class="lineNum">      25 </span>            : </a>
<a name="26"><span class="lineNum">      26 </span>            : </a>
<a name="27"><span class="lineNum">      27 </span>            : </a>
<a name="28"><span class="lineNum">      28 </span>            : architecture bench of top_estimator_tb is</a>
<a name="29"><span class="lineNum">      29 </span>            : </a>
<a name="30"><span class="lineNum">      30 </span>            : </a>
<a name="31"><span class="lineNum">      31 </span>            :   -- Clock period</a>
<a name="32"><span class="lineNum">      32 </span><span class="lineCov">          2 :   constant clk_period : time := 5 ns;</span></a>
<a name="33"><span class="lineNum">      33 </span>            :   -- Generics</a>
<a name="34"><span class="lineNum">      34 </span>            : </a>
<a name="35"><span class="lineNum">      35 </span>            :   -- Ports</a>
<a name="36"><span class="lineNum">      36 </span><span class="lineCov">          2 :   signal clk : std_logic;</span></a>
<a name="37"><span class="lineNum">      37 </span><span class="lineCov">          2 :   signal reset : std_logic;</span></a>
<a name="38"><span class="lineNum">      38 </span><span class="lineCov">         42 :   signal data_from_file : std_logic_vector (19 downto 0);</span></a>
<a name="39"><span class="lineNum">      39 </span><span class="lineCov">          2 :   signal data_from_file_valid : std_logic;</span></a>
<a name="40"><span class="lineNum">      40 </span><span class="lineCov">         42 :   signal data_channel_output : complex10;</span></a>
<a name="41"><span class="lineNum">      41 </span><span class="lineCov">          2 :   signal data_channel_output_valid : std_logic;</span></a>
<a name="42"><span class="lineNum">      42 </span>            :   </a>
<a name="43"><span class="lineNum">      43 </span>            : </a>
<a name="44"><span class="lineNum">      44 </span><span class="lineCov">          4 :   signal running : boolean := true;</span></a>
<a name="45"><span class="lineNum">      45 </span>            : begin</a>
<a name="46"><span class="lineNum">      46 </span>            : </a>
<a name="47"><span class="lineNum">      47 </span><span class="lineCov">          2 :   top_estimator_inst : entity src_lib.top_estimator</span></a>
<a name="48"><span class="lineNum">      48 </span>            :     port map (</a>
<a name="49"><span class="lineNum">      49 </span>            :       clk =&gt; clk,</a>
<a name="50"><span class="lineNum">      50 </span>            :       reset =&gt; reset,</a>
<a name="51"><span class="lineNum">      51 </span>            :       data_from_file =&gt; data_from_file,</a>
<a name="52"><span class="lineNum">      52 </span>            :       data_from_file_valid =&gt; data_from_file_valid,</a>
<a name="53"><span class="lineNum">      53 </span>            :       data_channel_output =&gt; data_channel_output,</a>
<a name="54"><span class="lineNum">      54 </span>            :       data_channel_output_valid =&gt; data_channel_output_valid</a>
<a name="55"><span class="lineNum">      55 </span>            :     );</a>
<a name="56"><span class="lineNum">      56 </span>            : </a>
<a name="57"><span class="lineNum">      57 </span>            :     </a>
<a name="58"><span class="lineNum">      58 </span><span class="lineCov">          2 :   main : process</span></a>
<a name="59"><span class="lineNum">      59 </span>            : </a>
<a name="60"><span class="lineNum">      60 </span><span class="lineCov">          2 :     variable in_csv : integer_array_t;</span></a>
<a name="61"><span class="lineNum">      61 </span><span class="lineCov">         10 :     variable line_in_csv : integer;</span></a>
<a name="62"><span class="lineNum">      62 </span>            : </a>
<a name="63"><span class="lineNum">      63 </span><span class="lineCov">         28 :     procedure seq_tran(constant input_tran: in input_tran_t) is</span></a>
<a name="64"><span class="lineNum">      64 </span><span class="lineCov">          2 :         variable msg : msg_t;</span></a>
<a name="65"><span class="lineNum">      65 </span><span class="lineCov">          2 :         variable msg_copy : msg_t;</span></a>
<a name="66"><span class="lineNum">      66 </span><span class="lineCov">          2 :         variable msg_copy_cover: msg_t;</span></a>
<a name="67"><span class="lineNum">      67 </span>            :       begin</a>
<a name="68"><span class="lineNum">      68 </span><span class="lineCov">          4 :         info(&quot;test_sequence: pushing:&quot; &amp; to_string(input_tran));</span></a>
<a name="69"><span class="lineNum">      69 </span><span class="lineCov">          2 :         msg := new_msg;</span></a>
<a name="70"><span class="lineNum">      70 </span><span class="lineCov">          4 :         push(msg, input_tran);</span></a>
<a name="71"><span class="lineNum">      71 </span><span class="lineCov">          2 :         msg_copy := copy(msg);</span></a>
<a name="72"><span class="lineNum">      72 </span><span class="lineCov">          2 :         msg_copy_cover := copy(msg);</span></a>
<a name="73"><span class="lineNum">      73 </span><span class="lineCov">          6 :         send(net, driver_receiver, msg);</span></a>
<a name="74"><span class="lineNum">      74 </span><span class="lineCov">          4 :         send(net, predictor_receiver, msg_copy);</span></a>
<a name="75"><span class="lineNum">      75 </span><span class="lineCov">          4 :         send(net, coverage_receiver_input, msg_copy_cover);</span></a>
<a name="76"><span class="lineNum">      76 </span><span class="lineCov">         54 :         wait for input_tran.cycles*clk_period;</span></a>
<a name="77"><span class="lineNum">      77 </span>            :       end procedure;</a>
<a name="78"><span class="lineNum">      78 </span>            : </a>
<a name="79"><span class="lineNum">      79 </span>            : </a>
<a name="80"><span class="lineNum">      80 </span>            : </a>
<a name="81"><span class="lineNum">      81 </span>            :   begin</a>
<a name="82"><span class="lineNum">      82 </span><span class="lineCov">          6 :     test_runner_setup(runner, runner_cfg);</span></a>
<a name="83"><span class="lineNum">      83 </span><span class="lineCov">          4 :     while test_suite loop</span></a>
<a name="84"><span class="lineNum">      84 </span><span class="lineCov">          2 :       if run(&quot;CSV_Import_Test&quot;) then</span></a>
<a name="85"><span class="lineNum">      85 </span><span class="lineCov">          4 :         info(&quot;CSV_Import_Test&quot;);</span></a>
<a name="86"><span class="lineNum">      86 </span>            : </a>
<a name="87"><span class="lineNum">      87 </span><span class="lineCov">          2 :         in_csv := load_csv(&quot;matlab-files/OFDM_QPSK_10_SYMB_re_im.csv&quot;, 32, true);</span></a>
<a name="88"><span class="lineNum">      88 </span>            : </a>
<a name="89"><span class="lineNum">      89 </span>            :         -- initialize fsm</a>
<a name="90"><span class="lineNum">      90 </span><span class="lineCov">          8 :         seq_tran((reset =&gt; true, cycles =&gt; 1, data_from_file =&gt; std_logic_vector(to_signed(1, 20)), data_from_file_valid =&gt; false));</span></a>
<a name="91"><span class="lineNum">      91 </span>            : </a>
<a name="92"><span class="lineNum">      92 </span><span class="lineCov">          2 :         for i in 0 to in_csv.height - 1 loop</span></a>
<a name="93"><span class="lineNum">      93 </span><span class="lineCov">          2 :             line_in_csv := get(in_csv, i);</span></a>
<a name="94"><span class="lineNum">      94 </span><span class="lineNoCov">          0 :             seq_tran((reset =&gt; false, cycles =&gt; 1, data_from_file =&gt; std_logic_vector(to_signed(line_in_csv, 20)), data_from_file_valid =&gt; true));</span></a>
<a name="95"><span class="lineNum">      95 </span>            :         end loop;</a>
<a name="96"><span class="lineNum">      96 </span>            : </a>
<a name="97"><span class="lineNum">      97 </span><span class="lineNoCov">          0 :         seq_tran((reset =&gt; false, cycles =&gt; 4000, data_from_file =&gt; std_logic_vector(to_signed(0, 20)), data_from_file_valid =&gt; false));</span></a>
<a name="98"><span class="lineNum">      98 </span>            : </a>
<a name="99"><span class="lineNum">      99 </span>            :         </a>
<a name="100"><span class="lineNum">     100 </span>            :       end if;</a>
<a name="101"><span class="lineNum">     101 </span>            :     end loop;</a>
<a name="102"><span class="lineNum">     102 </span><span class="lineNoCov">          0 :         running &lt;= false;</span></a>
<a name="103"><span class="lineNum">     103 </span><span class="lineCov">         28 :         test_runner_cleanup(runner);</span></a>
<a name="104"><span class="lineNum">     104 </span>            : </a>
<a name="105"><span class="lineNum">     105 </span>            :   end process main;</a>
<a name="106"><span class="lineNum">     106 </span>            : </a>
<a name="107"><span class="lineNum">     107 </span>            : </a>
<a name="108"><span class="lineNum">     108 </span>            : </a>
<a name="109"><span class="lineNum">     109 </span><span class="lineCov">          2 :   clk_process : process</span></a>
<a name="110"><span class="lineNum">     110 </span>            :   begin</a>
<a name="111"><span class="lineNum">     111 </span><span class="lineCov">          4 :   clk &lt;= '1';</span></a>
<a name="112"><span class="lineNum">     112 </span><span class="lineCov">          4 :   wait for clk_period/2;</span></a>
<a name="113"><span class="lineNum">     113 </span><span class="lineCov">          2 :   clk &lt;= '0';</span></a>
<a name="114"><span class="lineNum">     114 </span><span class="lineCov">         28 :   wait for clk_period/2;</span></a>
<a name="115"><span class="lineNum">     115 </span>            :   end process clk_process;</a>
<a name="116"><span class="lineNum">     116 </span>            : </a>
<a name="117"><span class="lineNum">     117 </span>            : </a>
<a name="118"><span class="lineNum">     118 </span>            : </a>
<a name="119"><span class="lineNum">     119 </span><span class="lineCov">          2 :   driver: process</span></a>
<a name="120"><span class="lineNum">     120 </span><span class="lineCov">          2 :     variable msg: msg_t;</span></a>
<a name="121"><span class="lineNum">     121 </span><span class="lineCov">         82 :     variable input_tran: input_tran_t; </span></a>
<a name="122"><span class="lineNum">     122 </span>            :   begin</a>
<a name="123"><span class="lineNum">     123 </span><span class="lineCov">          4 :     info(&quot;driver: waiting for transaction...&quot;);</span></a>
<a name="124"><span class="lineNum">     124 </span><span class="lineCov">          6 :     receive(net, driver_receiver, msg);</span></a>
<a name="125"><span class="lineNum">     125 </span><span class="lineCov">          2 :     input_tran := pop(msg);</span></a>
<a name="126"><span class="lineNum">     126 </span><span class="lineCov">          4 :     info(&quot;driver: received:&quot; &amp; to_string(input_tran));</span></a>
<a name="127"><span class="lineNum">     127 </span>            : </a>
<a name="128"><span class="lineNum">     128 </span><span class="lineCov">          2 :     if input_tran.reset then</span></a>
<a name="129"><span class="lineNum">     129 </span><span class="lineCov">          2 :       reset &lt;= '1';</span></a>
<a name="130"><span class="lineNum">     130 </span>            :     else</a>
<a name="131"><span class="lineNum">     131 </span><span class="lineNoCov">          0 :       reset &lt;= '0';</span></a>
<a name="132"><span class="lineNum">     132 </span>            :     end if;</a>
<a name="133"><span class="lineNum">     133 </span>            : </a>
<a name="134"><span class="lineNum">     134 </span><span class="lineCov">          2 :     if input_tran.data_from_file_valid then</span></a>
<a name="135"><span class="lineNum">     135 </span><span class="lineNoCov">          0 :       data_from_file_valid &lt;= '1';</span></a>
<a name="136"><span class="lineNum">     136 </span>            :     else</a>
<a name="137"><span class="lineNum">     137 </span><span class="lineCov">          2 :       data_from_file_valid &lt;= '0';</span></a>
<a name="138"><span class="lineNum">     138 </span>            :     end if;</a>
<a name="139"><span class="lineNum">     139 </span>            : </a>
<a name="140"><span class="lineNum">     140 </span><span class="lineCov">         42 :     data_from_file &lt;= input_tran.data_from_file;</span></a>
<a name="141"><span class="lineNum">     141 </span>            : </a>
<a name="142"><span class="lineNum">     142 </span><span class="lineCov">          2 :     for i in 0 to input_tran.cycles loop</span></a>
<a name="143"><span class="lineNum">     143 </span><span class="lineCov">         46 :       wait for clk_period;</span></a>
<a name="144"><span class="lineNum">     144 </span>            :     end loop;</a>
<a name="145"><span class="lineNum">     145 </span>            :   end process;</a>
<a name="146"><span class="lineNum">     146 </span>            : </a>
<a name="147"><span class="lineNum">     147 </span>            : </a>
<a name="148"><span class="lineNum">     148 </span><span class="lineCov">          2 :   monitor: process</span></a>
<a name="149"><span class="lineNum">     149 </span><span class="lineCov">          2 :     variable msg: msg_t;</span></a>
<a name="150"><span class="lineNum">     150 </span><span class="lineCov">         42 :     variable output_tran: output_tran_t;</span></a>
<a name="151"><span class="lineNum">     151 </span><span class="lineCov">          2 :     variable msg_copy_cover: msg_t; </span></a>
<a name="152"><span class="lineNum">     152 </span>            :   begin</a>
<a name="153"><span class="lineNum">     153 </span><span class="lineCov">         10 :     wait until falling_edge(clk);</span></a>
<a name="154"><span class="lineNum">     154 </span><span class="lineCov">          2 :         output_tran.data_channel_output_re := data_channel_output.re;</span></a>
<a name="155"><span class="lineNum">     155 </span><span class="lineCov">          2 :         output_tran.data_channel_output_im := data_channel_output.im;</span></a>
<a name="156"><span class="lineNum">     156 </span><span class="lineCov">          2 :         if data_channel_output_valid = '1' then</span></a>
<a name="157"><span class="lineNum">     157 </span><span class="lineNoCov">          0 :             output_tran.data_channel_output_valid := true;</span></a>
<a name="158"><span class="lineNum">     158 </span>            :         else</a>
<a name="159"><span class="lineNum">     159 </span><span class="lineCov">          2 :             output_tran.data_channel_output_valid := false;</span></a>
<a name="160"><span class="lineNum">     160 </span>            :         end if;</a>
<a name="161"><span class="lineNum">     161 </span>            : </a>
<a name="162"><span class="lineNum">     162 </span><span class="lineCov">          4 :         info(&quot;monitor: detected:&quot; &amp; to_string(output_tran));</span></a>
<a name="163"><span class="lineNum">     163 </span><span class="lineCov">          2 :         msg := new_msg;</span></a>
<a name="164"><span class="lineNum">     164 </span><span class="lineCov">          4 :         push(msg, output_tran);</span></a>
<a name="165"><span class="lineNum">     165 </span><span class="lineCov">         36 :         send(net, checker_receiver_actual, msg);                </span></a>
<a name="166"><span class="lineNum">     166 </span>            :   end process;</a>
<a name="167"><span class="lineNum">     167 </span>            : </a>
<a name="168"><span class="lineNum">     168 </span>            : </a>
<a name="169"><span class="lineNum">     169 </span><span class="lineCov">          2 :   printer: process</span></a>
<a name="170"><span class="lineNum">     170 </span><span class="lineCov">          2 :     variable outputs_re : integer_array_t;</span></a>
<a name="171"><span class="lineNum">     171 </span><span class="lineCov">          2 :     variable outputs_im : integer_array_t;</span></a>
<a name="172"><span class="lineNum">     172 </span>            :     begin</a>
<a name="173"><span class="lineNum">     173 </span>            : </a>
<a name="174"><span class="lineNum">     174 </span><span class="lineCov">          2 :       outputs_re := new_1d;</span></a>
<a name="175"><span class="lineNum">     175 </span><span class="lineCov">          2 :       outputs_im := new_1d;</span></a>
<a name="176"><span class="lineNum">     176 </span>            : </a>
<a name="177"><span class="lineNum">     177 </span>            :     -- While the simulation is running, append output data to our output vector</a>
<a name="178"><span class="lineNum">     178 </span><span class="lineCov">          6 :     while (running) loop</span></a>
<a name="179"><span class="lineNum">     179 </span><span class="lineCov">         10 :       wait until falling_edge(clk);</span></a>
<a name="180"><span class="lineNum">     180 </span><span class="lineCov">          2 :         if data_channel_output_valid = '1' then</span></a>
<a name="181"><span class="lineNum">     181 </span><span class="lineNoCov">          0 :         append(outputs_re, to_integer(data_channel_output.re));</span></a>
<a name="182"><span class="lineNum">     182 </span><span class="lineCov">          2 :         append(outputs_im, to_integer(data_channel_output.im));</span></a>
<a name="183"><span class="lineNum">     183 </span>            :         end if;</a>
<a name="184"><span class="lineNum">     184 </span>            :     end loop;</a>
<a name="185"><span class="lineNum">     185 </span>            : </a>
<a name="186"><span class="lineNum">     186 </span>            :     -- When no more clock cycles are expected, write the file and free the</a>
<a name="187"><span class="lineNum">     187 </span>            :     -- memory used for the output vector</a>
<a name="188"><span class="lineNum">     188 </span><span class="lineNoCov">          0 :     save_csv(outputs_re,&quot;channel_output_re.csv&quot;);</span></a>
<a name="189"><span class="lineNum">     189 </span><span class="lineNoCov">          0 :     save_csv(outputs_im,&quot;channel_output_im.csv&quot;);</span></a>
<a name="190"><span class="lineNum">     190 </span><span class="lineNoCov">          0 :     deallocate(outputs_re);</span></a>
<a name="191"><span class="lineNum">     191 </span><span class="lineNoCov">          0 :     deallocate(outputs_im);</span></a>
<a name="192"><span class="lineNum">     192 </span><span class="lineCov">         14 :     wait;</span></a>
<a name="193"><span class="lineNum">     193 </span>            :   end process;</a>
<a name="194"><span class="lineNum">     194 </span>            : </a>
<a name="195"><span class="lineNum">     195 </span>            : </a>
<a name="196"><span class="lineNum">     196 </span>            : </a>
<a name="197"><span class="lineNum">     197 </span>            : -- add coverage later</a>
<a name="198"><span class="lineNum">     198 </span>            : </a>
<a name="199"><span class="lineNum">     199 </span>            : </a>
<a name="200"><span class="lineNum">     200 </span>            : --   coverage_input: process</a>
<a name="201"><span class="lineNum">     201 </span>            : --     variable msg: msg_t;</a>
<a name="202"><span class="lineNum">     202 </span>            : --     variable input_tran: input_tran_t;</a>
<a name="203"><span class="lineNum">     203 </span>            : </a>
<a name="204"><span class="lineNum">     204 </span>            : --     function bool2int (bool: boolean) return integer is</a>
<a name="205"><span class="lineNum">     205 </span>            : --       variable retval : integer;</a>
<a name="206"><span class="lineNum">     206 </span>            : --     begin</a>
<a name="207"><span class="lineNum">     207 </span>            : --       if bool then</a>
<a name="208"><span class="lineNum">     208 </span>            : --         retval := 1;</a>
<a name="209"><span class="lineNum">     209 </span>            : --       else</a>
<a name="210"><span class="lineNum">     210 </span>            : --         retval := 0;</a>
<a name="211"><span class="lineNum">     211 </span>            : --       end if;</a>
<a name="212"><span class="lineNum">     212 </span>            : --       return retval;</a>
<a name="213"><span class="lineNum">     213 </span>            : --     end;</a>
<a name="214"><span class="lineNum">     214 </span>            : </a>
<a name="215"><span class="lineNum">     215 </span>            : --   begin</a>
<a name="216"><span class="lineNum">     216 </span>            : --     AddBins(cover_reset, GenBin(0,1));</a>
<a name="217"><span class="lineNum">     217 </span>            : --     AddBins(cover_enable, GenBin(0,1));</a>
<a name="218"><span class="lineNum">     218 </span>            : --     AddBins(cover_cycles, GenBin(0,511,4));</a>
<a name="219"><span class="lineNum">     219 </span>            : --     while true loop</a>
<a name="220"><span class="lineNum">     220 </span>            : --       receive(net, coverage_receiver_input, msg);</a>
<a name="221"><span class="lineNum">     221 </span>            : --       input_tran := pop(msg);</a>
<a name="222"><span class="lineNum">     222 </span>            : --       icover(cover_reset, bool2int(input_tran.reset));</a>
<a name="223"><span class="lineNum">     223 </span>            : --       icover(cover_enable, bool2int(input_tran.enable));</a>
<a name="224"><span class="lineNum">     224 </span>            : --       icover(cover_cycles, input_tran.cycles);</a>
<a name="225"><span class="lineNum">     225 </span>            : --     end loop;</a>
<a name="226"><span class="lineNum">     226 </span>            : --   end process;</a>
<a name="227"><span class="lineNum">     227 </span>            : </a>
<a name="228"><span class="lineNum">     228 </span>            : --   coverage_output: process</a>
<a name="229"><span class="lineNum">     229 </span>            : --     variable msg: msg_t;</a>
<a name="230"><span class="lineNum">     230 </span>            : --     variable output_tran: output_tran_t;</a>
<a name="231"><span class="lineNum">     231 </span>            : --   begin</a>
<a name="232"><span class="lineNum">     232 </span>            : --     AddBins(cover_data_channel_output, GenBin(0,524287,4));</a>
<a name="233"><span class="lineNum">     233 </span>            : --     while true loop</a>
<a name="234"><span class="lineNum">     234 </span>            : --       receive(net, coverage_receiver_output, msg);</a>
<a name="235"><span class="lineNum">     235 </span>            : --       output_tran := pop(msg);</a>
<a name="236"><span class="lineNum">     236 </span>            : --       icover(cover_value, output_tran.value);</a>
<a name="237"><span class="lineNum">     237 </span>            : --     end loop;</a>
<a name="238"><span class="lineNum">     238 </span>            : --   end process;</a>
<a name="239"><span class="lineNum">     239 </span>            : </a>
<a name="240"><span class="lineNum">     240 </span>            : </a>
<a name="241"><span class="lineNum">     241 </span>            : </a>
<a name="242"><span class="lineNum">     242 </span>            : end;</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
